unit asUnitMain;

{

Delphi Thread Pool Example Using AsyncCalls
AsyncCalls Unit By Andreas Hausladen - Let's Use (and Extend) It!

http://delphi.about.com/od/kbthread/a/delphi-thread-pool-example-using-asynccalls.htm

by Zarko Gajic

}

interface

uses
  AsyncCalls, AsyncCallsHelper,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin;

type
  TAsyncCallsForm = class(TForm)
    Memo1: TMemo;
    btnAddTasks: TButton;
    btnCancelAll: TButton;
    procedure btnAddTasksClick(Sender: TObject);
    procedure btnCancelAllClick(Sender: TObject);
  private
    function AsyncMethod(taskNr, sleepTime: integer) : integer;
    procedure Log(const s : string);
    procedure ClearLog(const s: string);
  public
    arr : array of IAsyncCall;
  end;

var
  AsyncCallsForm: TAsyncCallsForm;

implementation
{$R *.dfm}

procedure TAsyncCallsForm.btnAddTasksClick(Sender: TObject);
const
  nrItems = 200;
var
  i : integer;
begin
  asyncHelper.MaxThreads := 2 * System.CPUCount;

  ClearLog('starting');

  for i := 1 to nrItems do
  begin
    asyncHelper.AddTask(TAsyncCalls.Invoke<integer, integer>(AsyncMethod, i, Random(500)));
  end;

  Log('all in');

  //wait all
  //asyncHelper.WaitAll;

  //or allow canceling all not started by clicking the "Cancel All" button:
  while NOT asyncHelper.AllFinished do Application.ProcessMessages;

  Log('finished');
end;

procedure TAsyncCallsForm.btnCancelAllClick(Sender: TObject);
begin
  asyncHelper.CancelAll;
end;

procedure TAsyncCallsForm.ClearLog(const s: string);
begin
  Memo1.Clear;
  Log(s);
end;

procedure TAsyncCallsForm.Log(const s: string);
begin
  Memo1.Lines.Add(s);
end;

function TAsyncCallsForm.AsyncMethod(taskNr, sleepTime: integer): integer;
begin
  result := sleepTime;

  Sleep(sleepTime);

  TAsyncCalls.VCLInvoke(
  procedure
  begin
    Log(Format('done > nr: %d / tasks: %d /  slept: %d', [tasknr, asyncHelper.TaskCount, sleepTime]));
  end);
end;



end.
